Index: palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 4766)
+++ palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 4767)
@@ -3968,171 +3594,172 @@
 #if defined( __netcdf4_parallel )
 !
-!--    If __netcdf4_parallel is defined, parrallel NetCDF will be used.
-       nc_stat = NF90_OPEN( filename, IOR( NF90_NOWRITE, NF90_MPIIO ), id,     &
-                            COMM = comm2d, INFO = MPI_INFO_NULL )
-!
-!--    In case the previous open call fails, check for possible Netcdf 3 file,
-!--    and open it. However, this case, disable parallel access. 
-       IF( nc_stat /= NF90_NOERR )  THEN
-          nc_stat = NF90_OPEN( filename, NF90_NOWRITE, id )
-          collective_read = .FALSE.
-       ELSE
+!-- If __netcdf4_parallel is defined, parrallel NetCDF will be used.
+    nc_stat = NF90_OPEN( filename, IOR( NF90_NOWRITE, NF90_MPIIO ), id, COMM = comm2d,             &
+                         INFO = MPI_INFO_NULL )
+!
+!-- In case the previous open call fails, check for possible Netcdf 3 file, and open it. However,
+!-- this case, disable parallel access.
+    IF( nc_stat /= NF90_NOERR )  THEN
+       nc_stat = NF90_OPEN( filename, NF90_NOWRITE, id )
+       collective_read = .FALSE.
+    ELSE
 #if defined( __nec )
-          collective_read = .FALSE.   ! collective read causes hang situations on NEC Aurora
+       collective_read = .FALSE.   ! collective read causes hang situations on NEC Aurora
 #else
-          collective_read = .TRUE.
+       collective_read = .TRUE.
 #endif
-       ENDIF
+    ENDIF
 #else
 !
-!--    All MPI processes open the file and read it (but not in parallel).
-       nc_stat = NF90_OPEN( filename, NF90_NOWRITE, id )
+!-- All MPI processes open the file and read it (but not in parallel).
+    nc_stat = NF90_OPEN( filename, NF90_NOWRITE, id )
 #endif
 
-       CALL handle_error( 'open_read_file', 539 )
+    CALL handle_error( 'open_read_file', 539 )
 
 #endif
-    END SUBROUTINE open_read_file
-
-!------------------------------------------------------------------------------!
+ END SUBROUTINE open_read_file
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Reads global or variable-related attributes of type INTEGER (32-bit)
-!------------------------------------------------------------------------------!
-     SUBROUTINE get_attribute_int32( id, attribute_name, value, global,        &
-                                     variable_name, no_abort )
-
-       USE pegrid
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=*)            ::  attribute_name   !< attribute name
-       CHARACTER(LEN=*), OPTIONAL  ::  variable_name    !< variable name
-
-       INTEGER(iwp), INTENT(IN)    ::  id               !< file id
-       INTEGER(iwp)                ::  id_var           !< variable id
-       INTEGER(iwp), INTENT(INOUT) ::  value            !< read value
-
-       LOGICAL                       ::  check_error    !< flag indicating if handle_error shall be checked
-       LOGICAL, INTENT(IN)           ::  global         !< flag indicating global attribute
-       LOGICAL, INTENT(IN), OPTIONAL ::  no_abort       !< flag indicating if errors should be checked
+!--------------------------------------------------------------------------------------------------!
+  SUBROUTINE get_attribute_int32( id, attribute_name, value, global, variable_name, no_abort )
+
+    USE pegrid
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*)            ::  attribute_name   !< attribute name
+    CHARACTER(LEN=*), OPTIONAL  ::  variable_name    !< variable name
+
+    INTEGER(iwp), INTENT(IN)    ::  id               !< file id
+    INTEGER(iwp)                ::  id_var           !< variable id
+    INTEGER(iwp), INTENT(INOUT) ::  value            !< read value
+
+    LOGICAL                       ::  check_error    !< flag indicating if handle_error shall be checked
+    LOGICAL, INTENT(IN)           ::  global         !< flag indicating global attribute
+    LOGICAL, INTENT(IN), OPTIONAL ::  no_abort       !< flag indicating if errors should be checked
 #if defined( __netcdf )
 
-       IF ( PRESENT( no_abort ) )  THEN
-          check_error = no_abort
-       ELSE
-          check_error = .TRUE.
-       ENDIF
-!
-!--    Read global attribute
-       IF ( global )  THEN
-          nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
-          IF ( check_error)  CALL handle_error( 'get_attribute_int32 global', 522, attribute_name )
-!
-!--    Read attributes referring to a single variable. Therefore, first inquire
-!--    variable id
-       ELSE
-          nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-          IF ( check_error)  CALL handle_error( 'get_attribute_int32', 522, attribute_name )
-          nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
-          IF ( check_error)  CALL handle_error( 'get_attribute_int32', 522, attribute_name )
-       ENDIF
+    IF ( PRESENT( no_abort ) )  THEN
+       check_error = no_abort
+    ELSE
+       check_error = .TRUE.
+    ENDIF
+!
+!-- Read global attribute
+    IF ( global )  THEN
+       nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
+       IF ( check_error)  CALL handle_error( 'get_attribute_int32 global', 522, attribute_name )
+!
+!-- Read attributes referring to a single variable. Therefore, first inquire variable id
+    ELSE
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
+       IF ( check_error)  CALL handle_error( 'get_attribute_int32', 522, attribute_name )
+       nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
+       IF ( check_error)  CALL handle_error( 'get_attribute_int32', 522, attribute_name )
+    ENDIF
 #endif
-    END SUBROUTINE get_attribute_int32
-
-!------------------------------------------------------------------------------!
+
+ END SUBROUTINE get_attribute_int32
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Reads global or variable-related attributes of type INTEGER (8-bit)
-!------------------------------------------------------------------------------!
-     SUBROUTINE get_attribute_int8( id, attribute_name, value, global,         &
-                                    variable_name, no_abort )
-
-       USE pegrid
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=*)            ::  attribute_name   !< attribute name
-       CHARACTER(LEN=*), OPTIONAL  ::  variable_name    !< variable name
-
-       INTEGER(iwp), INTENT(IN)    ::  id               !< file id
-       INTEGER(iwp)                ::  id_var           !< variable id
-       INTEGER(KIND=1), INTENT(INOUT) ::  value         !< read value
-
-       LOGICAL                       ::  check_error    !< flag indicating if handle_error shall be checked
-       LOGICAL, INTENT(IN), OPTIONAL ::  no_abort       !< flag indicating if errors should be checked
-       LOGICAL, INTENT(IN)           ::  global         !< flag indicating global attribute
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE get_attribute_int8( id, attribute_name, value, global, variable_name, no_abort )
+
+    USE pegrid
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*)            ::  attribute_name   !< attribute name
+    CHARACTER(LEN=*), OPTIONAL  ::  variable_name    !< variable name
+
+    INTEGER(iwp), INTENT(IN)    ::  id               !< file id
+    INTEGER(iwp)                ::  id_var           !< variable id
+    INTEGER(KIND=1), INTENT(INOUT) ::  value         !< read value
+
+    LOGICAL                       ::  check_error    !< flag indicating if handle_error shall be checked
+    LOGICAL, INTENT(IN), OPTIONAL ::  no_abort       !< flag indicating if errors should be checked
+    LOGICAL, INTENT(IN)           ::  global         !< flag indicating global attribute
 #if defined( __netcdf )
 
-       IF ( PRESENT( no_abort ) )  THEN
-          check_error = no_abort
-       ELSE
-          check_error = .TRUE.
-       ENDIF
-!
-!--    Read global attribute
-       IF ( global )  THEN
-          nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
-          IF ( check_error)  CALL handle_error( 'get_attribute_int8 global', 523, attribute_name )
-!
-!--    Read attributes referring to a single variable. Therefore, first inquire
-!--    variable id
-       ELSE
-          nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-          IF ( check_error)  CALL handle_error( 'get_attribute_int8', 523, attribute_name )
-          nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
-          IF ( check_error)  CALL handle_error( 'get_attribute_int8', 523, attribute_name )
-       ENDIF
+    IF ( PRESENT( no_abort ) )  THEN
+       check_error = no_abort
+    ELSE
+       check_error = .TRUE.
+    ENDIF
+!
+!-- Read global attribute
+    IF ( global )  THEN
+       nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
+       IF ( check_error)  CALL handle_error( 'get_attribute_int8 global', 523, attribute_name )
+!
+!-- Read attributes referring to a single variable. Therefore, first inquire variable id
+    ELSE
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
+       IF ( check_error)  CALL handle_error( 'get_attribute_int8', 523, attribute_name )
+       nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
+       IF ( check_error)  CALL handle_error( 'get_attribute_int8', 523, attribute_name )
+    ENDIF
 #endif
-    END SUBROUTINE get_attribute_int8
-
-!------------------------------------------------------------------------------!
+
+ END SUBROUTINE get_attribute_int8
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Reads global or variable-related attributes of type REAL
-!------------------------------------------------------------------------------!
-     SUBROUTINE get_attribute_real( id, attribute_name, value, global,         &
-                                    variable_name, no_abort )
-
-       USE pegrid
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=*)            ::  attribute_name   !< attribute name
-       CHARACTER(LEN=*), OPTIONAL  ::  variable_name    !< variable name
-
-       INTEGER(iwp), INTENT(IN)    ::  id               !< file id
-       INTEGER(iwp)                ::  id_var           !< variable id
-
-       LOGICAL                       ::  check_error    !< flag indicating if handle_error shall be checked
-       LOGICAL, INTENT(IN)           ::  global         !< flag indicating global attribute
-       LOGICAL, INTENT(IN), OPTIONAL ::  no_abort       !< flag indicating if errors should be checked
-
-       REAL(wp), INTENT(INOUT)     ::  value            !< read value
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE get_attribute_real( id, attribute_name, value, global, variable_name, no_abort )
+
+    USE pegrid
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*)            ::  attribute_name   !< attribute name
+    CHARACTER(LEN=*), OPTIONAL  ::  variable_name    !< variable name
+
+    INTEGER(iwp), INTENT(IN)    ::  id               !< file id
+    INTEGER(iwp)                ::  id_var           !< variable id
+
+    LOGICAL                       ::  check_error    !< flag indicating if handle_error shall be checked
+    LOGICAL, INTENT(IN)           ::  global         !< flag indicating global attribute
+    LOGICAL, INTENT(IN), OPTIONAL ::  no_abort       !< flag indicating if errors should be checked
+
+    REAL(wp), INTENT(INOUT)     ::  value            !< read value
 #if defined( __netcdf )
 
-       IF ( PRESENT( no_abort ) )  THEN
-          check_error = no_abort
-       ELSE
-          check_error = .TRUE.
-       ENDIF
-!
-!--    Read global attribute
-       IF ( global )  THEN
-          nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
-          IF ( check_error)  CALL handle_error( 'get_attribute_real global', 524, attribute_name )
-!
-!--    Read attributes referring to a single variable. Therefore, first inquire
-!--    variable id
-       ELSE
-          nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-          IF ( check_error)  CALL handle_error( 'get_attribute_real', 524, attribute_name )
-          nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
-          IF ( check_error)  CALL handle_error( 'get_attribute_real', 524, attribute_name )
-       ENDIF
+    IF ( PRESENT( no_abort ) )  THEN
+       check_error = no_abort
+    ELSE
+       check_error = .TRUE.
+    ENDIF
+!
+!-- Read global attribute
+    IF ( global )  THEN
+       nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
+       IF ( check_error)  CALL handle_error( 'get_attribute_real global', 524, attribute_name )
+!
+!-- Read attributes referring to a single variable. Therefore, first inquire variable id
+    ELSE
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
+       IF ( check_error)  CALL handle_error( 'get_attribute_real', 524, attribute_name )
+       nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
+       IF ( check_error)  CALL handle_error( 'get_attribute_real', 524, attribute_name )
+    ENDIF
 #endif
-    END SUBROUTINE get_attribute_real
-
-!------------------------------------------------------------------------------!
+
+ END SUBROUTINE get_attribute_real
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
@@ -4140,212 +3767,196 @@
 !> Remark: reading attributes of type NF_STRING return an error code 56 -
 !> Attempt to convert between text & numbers.
-!------------------------------------------------------------------------------!
-     SUBROUTINE get_attribute_string( id, attribute_name, value, global,       &
-                                      variable_name, no_abort )
-
-       USE pegrid
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=*)                ::  attribute_name   !< attribute name
-       CHARACTER(LEN=*), OPTIONAL      ::  variable_name    !< variable name
-       CHARACTER(LEN=*), INTENT(INOUT) ::  value            !< read value
-
-       INTEGER(iwp), INTENT(IN)    ::  id               !< file id
-       INTEGER(iwp)                ::  id_var           !< variable id
-
-       LOGICAL ::  check_error                          !< flag indicating if handle_error shall be checked
-       LOGICAL, INTENT(IN) ::  global                   !< flag indicating global attribute
-       LOGICAL, INTENT(IN), OPTIONAL ::  no_abort       !< flag indicating if errors should be checked
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE get_attribute_string( id, attribute_name, value, global, variable_name, no_abort )
+
+    USE pegrid
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*)                ::  attribute_name   !< attribute name
+    CHARACTER(LEN=*), INTENT(INOUT) ::  value            !< read value
+    CHARACTER(LEN=*), OPTIONAL      ::  variable_name    !< variable name
+
+    INTEGER(iwp), INTENT(IN)    ::  id               !< file id
+    INTEGER(iwp)                ::  id_var           !< variable id
+
+    LOGICAL ::  check_error                          !< flag indicating if handle_error shall be checked
+    LOGICAL, INTENT(IN) ::  global                   !< flag indicating global attribute
+    LOGICAL, INTENT(IN), OPTIONAL ::  no_abort       !< flag indicating if errors should be checked
 #if defined( __netcdf )
 
-       IF ( PRESENT( no_abort ) )  THEN
-          check_error = no_abort
-       ELSE
-          check_error = .TRUE.
-       ENDIF
-!
-!--    Read global attribute
-       IF ( global )  THEN
-          nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
-          IF ( check_error)  CALL handle_error( 'get_attribute_string global', 525, attribute_name )
-!
-!--    Read attributes referring to a single variable. Therefore, first inquire
-!--    variable id
-       ELSE
-          nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-          IF ( check_error)  CALL handle_error( 'get_attribute_string', 525, attribute_name )
-
-          nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
-          IF ( check_error)  CALL handle_error( 'get_attribute_string',525, attribute_name )
-
-       ENDIF
+    IF ( PRESENT( no_abort ) )  THEN
+       check_error = no_abort
+    ELSE
+       check_error = .TRUE.
+    ENDIF
+!
+!-- Read global attribute
+    IF ( global )  THEN
+       nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
+       IF ( check_error)  CALL handle_error( 'get_attribute_string global', 525, attribute_name )
+!
+!-- Read attributes referring to a single variable. Therefore, first inquire variable id
+    ELSE
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
+       IF ( check_error)  CALL handle_error( 'get_attribute_string', 525, attribute_name )
+
+       nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
+       IF ( check_error)  CALL handle_error( 'get_attribute_string',525, attribute_name )
+
+    ENDIF
 #endif
-    END SUBROUTINE get_attribute_string
-
-
-
-!------------------------------------------------------------------------------!
+
+ END SUBROUTINE get_attribute_string
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Get dimension array for a given dimension
-!------------------------------------------------------------------------------!
-     SUBROUTINE get_dimension_length( id, dim_len, variable_name )
-       USE pegrid
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=*)            ::  variable_name    !< dimension name
-       CHARACTER(LEN=100)          ::  dum              !< dummy variable to receive return character
-
-       INTEGER(iwp)                ::  dim_len          !< dimension size
-       INTEGER(iwp), INTENT(IN)    ::  id               !< file id
-       INTEGER(iwp)                ::  id_dim           !< dimension id
+!--------------------------------------------------------------------------------------------------!
+  SUBROUTINE get_dimension_length( id, dim_len, variable_name )
+    USE pegrid
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=100)          ::  dum              !< dummy variable to receive return character
+    CHARACTER(LEN=*)            ::  variable_name    !< dimension name
+
+    INTEGER(iwp)                ::  dim_len          !< dimension size
+    INTEGER(iwp), INTENT(IN)    ::  id               !< file id
+    INTEGER(iwp)                ::  id_dim           !< dimension id
 
 #if defined( __netcdf )
 !
-!--    First, inquire dimension ID
-       nc_stat = NF90_INQ_DIMID( id, TRIM( variable_name ), id_dim )
-       CALL handle_error( 'get_dimension_length', 526, variable_name )
-!
-!--    Inquire dimension length
-       nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim, dum, LEN = dim_len )
-       CALL handle_error( 'get_dimension_length', 526, variable_name )
+!-- First, inquire dimension ID
+    nc_stat = NF90_INQ_DIMID( id, TRIM( variable_name ), id_dim )
+    CALL handle_error( 'get_dimension_length', 526, variable_name )
+!
+!-- Inquire dimension length
+    nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim, dum, LEN = dim_len )
+    CALL handle_error( 'get_dimension_length', 526, variable_name )
 
 #endif
-    END SUBROUTINE get_dimension_length
-
-!------------------------------------------------------------------------------!
+
+ END SUBROUTINE get_dimension_length
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Routine for reading-in a character string from the chem emissions netcdf 
-!> input file.  
-!------------------------------------------------------------------------------!
-
-    SUBROUTINE get_variable_string( id, variable_name, var_string, names_number )
-
-       USE indices
-       USE pegrid
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=25), ALLOCATABLE, DIMENSION(:), INTENT(INOUT)  :: var_string
-
-       CHARACTER(LEN=*)                                              :: variable_name          !> variable name 
-
-       CHARACTER (LEN=1), ALLOCATABLE, DIMENSION(:,:)                :: tmp_var_string         !> variable to be read
-
-
-       INTEGER(iwp), INTENT(IN)                                      :: id                     !> file id
-
-       INTEGER(iwp), INTENT(IN)                                      :: names_number           !> number of names
-
-       INTEGER(iwp)                                                  :: id_var                 !> variable id
-
-       INTEGER(iwp)                                                  :: i,j                    !> index to go through the length of the dimensions
-
-       INTEGER(iwp)                                                  :: max_string_length=25   !> this is both the maximum length of a name, but also  
-                                                                                            ! the number of the components of the first dimensions
-                                                                                            ! (rows)
+!> Routine for reading-in a character string from the chem emissions netcdf input file.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE get_variable_string( id, variable_name, var_string, names_number )
+
+    USE indices
+    USE pegrid
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*)                                             :: variable_name    !< variable name
+    CHARACTER (LEN=25), ALLOCATABLE, DIMENSION(:), INTENT(INOUT)  :: var_string
+    CHARACTER (LEN=1), ALLOCATABLE, DIMENSION(:,:)                :: tmp_var_string   !< variable to be read
+
+    INTEGER(iwp)              :: i,j                    !< index to go through the length of the dimensions
+    INTEGER(iwp), INTENT(IN)  :: id                     !< file id
+    INTEGER(iwp)              :: id_var                 !< variable id
+    INTEGER(iwp), INTENT(IN)  :: names_number           !< number of names
+    INTEGER(iwp)              :: max_string_length=25   !< this is both the maximum length of a name, but also the number of the
+                                                        !< components of the first dimensions (rows)
 #if defined( __netcdf )
 
-       ALLOCATE(tmp_var_string(max_string_length,names_number))
-
-       ALLOCATE(var_string(names_number))
-
-    !-- Inquire variable id
-       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-
-
-    !-- Get variable
-    !-- Start cycle over the emission species
-       DO i = 1, names_number 
-       !-- read the first letter of each component
-          nc_stat = NF90_GET_VAR( id, id_var, var_string(i), start = (/ 1,i /), &
-                                 count = (/ 1,1 /) )
-          CALL handle_error( 'get_variable_string', 701 )
-
-       !-- Start cycle over charachters
-          DO j = 1, max_string_length
-                       
-          !-- read the rest of the components of the name
-             nc_stat = NF90_GET_VAR( id, id_var, tmp_var_string(j,i), start = (/ j,i /),&
-                                     count = (/ 1,1 /) )
-             CALL handle_error( 'get_variable_string', 702 )
-
-             IF ( iachar(tmp_var_string(j,i) ) == 0 ) THEN
-                  tmp_var_string(j,i)=''
-             ENDIF
-
-             IF ( j>1 ) THEN
-             !-- Concatenate first letter of the name and the others
-                var_string(i)=TRIM(var_string(i)) // TRIM(tmp_var_string(j,i))
-
-             ENDIF 
-          ENDDO 
+    ALLOCATE( tmp_var_string(max_string_length,names_number) )
+
+    ALLOCATE( var_string(names_number) )
+
+!-- Inquire variable id
+    nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
+
+!
+!-- Get variable
+!-- Start cycle over the emission species
+    DO  i = 1, names_number
+!
+!--    Read the first letter of each component
+       nc_stat = NF90_GET_VAR( id, id_var, var_string(i), start = (/ 1,i /), count = (/ 1,1 /) )
+       CALL handle_error( 'get_variable_string', 701 )
+!
+!--    Start cycle over charachters
+       DO  j = 1, max_string_length
+!
+!--       Read the rest of the components of the name
+          nc_stat = NF90_GET_VAR( id, id_var, tmp_var_string(j,i), start = (/ j,i /),              &
+                                  count = (/ 1,1 /) )
+          CALL handle_error( 'get_variable_string', 702 )
+
+          IF ( IACHAR( tmp_var_string(j,i) ) == 0 )  THEN
+               tmp_var_string(j,i)=''
+          ENDIF
+
+          IF ( j>1 )  THEN
+!
+!--          Concatenate first letter of the name and the others
+             var_string(i)=TRIM( var_string(i) ) // TRIM( tmp_var_string(j,i) )
+          ENDIF
        ENDDO
+    ENDDO
 
 #endif
-    END SUBROUTINE get_variable_string
-
-
-!
-!------------------------------------------------------------------------------!
+
+ END SUBROUTINE get_variable_string
+
+
+!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Generalized routine for reading strings from a netCDF variable
-!> to replace existing get_variable_string ( )
+!> Generalized routine for reading strings from a netCDF variable to replace existing
+!> get_variable_string ( )
 !>
 !> Improvements:
 !>   - Expanded string size limit from 25 to 512
-!>   - No longer removes spaces between text magically (this seems to have
-!>     been aimed at a very specific application, but I don't know what)
+!>   - No longer removes spaces between text magically (this seems to have been aimed at a very
+!>     specific application, but I don't know what)
 !>   - Simplified implementation
 !>
 !> Caveats:
-!>   - Somehow I could not get the subroutine to work with str_array(:,:)
-!>     so I reverted to a hard-coded str_array(:,512), hopefully large enough
-!>     for most general applications.  This also means the character variable
-!>     used for str_array must be of size (:,512)
-!>     (ecc 20200128)    
-!------------------------------------------------------------------------------!
-
+!>   - Somehow I could not get the subroutine to work with str_array(:,:) so I reverted to a
+!>     hard-coded str_array(:,512), hopefully large enough for most general applications. This also
+!>     means the character variable used for str_array must be of size (:,512)
+!>     (ecc 20200128)
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE get_variable_string_generic ( id, var_name, str_array, num_str, str_len )
 
     IMPLICIT NONE
 
-    CHARACTER(LEN=*),                INTENT(IN)    :: var_name       !> netCDF variable name
-    CHARACTER(LEN=512), ALLOCATABLE, INTENT(INOUT) :: str_array(:)   !> output string array
-
-    INTEGER(iwp)              :: buf_len   !> string buffer size
-    INTEGER(iwp)              :: id_var    !> netCDF variable ID
-    INTEGER(iwp)              :: k         !> generic counter
-
-    INTEGER(iwp), INTENT(IN)  :: id        !> netCDF file ID
-    INTEGER(iwp), INTENT(IN)  :: num_str   !> number of string elements in array
-    INTEGER(iwp), INTENT(IN)  :: str_len   !> size of each string element
+    CHARACTER(LEN=*),                INTENT(IN)    :: var_name       !< netCDF variable name
+    CHARACTER(LEN=512), ALLOCATABLE, INTENT(INOUT) :: str_array(:)   !< output string array
+
+    INTEGER(iwp)              :: buf_len   !< string buffer size
+    INTEGER(iwp)              :: id_var    !< netCDF variable ID
+    INTEGER(iwp), INTENT(IN)  :: id        !< netCDF file ID
+    INTEGER(iwp)              :: k         !< generic counter
+    INTEGER(iwp), INTENT(IN)  :: num_str   !< number of string elements in array
+    INTEGER(iwp), INTENT(IN)  :: str_len   !< size of each string element
 
 #if defined( __netcdf )
 
 !
-!-- set buffer length to up to hard-coded string size
-
+!-- Set buffer length to up to hard-coded string size
     buf_len = MIN( ABS(str_len), 512 )
 
 !
-!-- allocate necessary memories for string variables
-
-    ALLOCATE(str_array(num_str))
-!
-!-- get variable id
-
+!-- Allocate necessary memories for string variables
+    ALLOCATE( str_array(num_str) )
+!
+!-- Get variable id
     nc_stat = NF90_INQ_VARID( id, TRIM(var_name), id_var )
 !
-!-- extract string variables
-
-    DO k = 1, num_str
+!-- Extract string variables
+    DO  k = 1, num_str
        str_array(k) = ''
-       nc_stat = NF90_GET_VAR( id, id_var, str_array(k),  &
-                      start = (/ 1, k /), count = (/ buf_len, 1 /)  )
+       nc_stat = NF90_GET_VAR( id, id_var, str_array(k), start = (/ 1, k /),                       &
+                               count = (/ buf_len, 1 /)  )
        CALL handle_error ( 'get_variable_string_generic', 702 )
     ENDDO
